## dahdi-linux 2.5.0.1+dfsg

=== Makefile ===
#
# Makefile for DAHDI Linux kernel modules
#
# Copyright (C) 2001-2010 Digium, Inc.
#
#

PWD:=$(shell pwd)

DAHDI_MODULES_EXTRA:=$(MODULES_EXTRA:%=%.o) $(SUBDIRS_EXTRA:%=%/)

# If you want to build for a kernel other than the current kernel, set KVERS
ifndef KVERS
KVERS:=$(shell uname -r)
endif
ifndef KSRC
  ifneq (,$(wildcard /lib/modules/$(KVERS)/build))
    KSRC:=/lib/modules/$(KVERS)/build
  else
    KSRC_SEARCH_PATH:=/usr/src/linux
    KSRC:=$(shell for dir in $(KSRC_SEARCH_PATH); do if [ -d $$dir ]; then echo $$dir; break; fi; done)
  endif
endif
KVERS_MAJ:=$(shell echo $(KVERS) | cut -d. -f1-2)
KINCLUDES:=$(KSRC)/include

# We use the kernel's .config file as an indication that the KSRC
# directory is indeed a valid and configured kernel source (or partial
# source) directory.
#
# We also source it, as it has the format of Makefile variables list.
# Thus we will have many CONFIG_* variables from there.
KCONFIG:=$(KSRC)/.config
ifneq (,$(wildcard $(KCONFIG)))
  HAS_KSRC:=yes
  include $(KCONFIG)
else
  HAS_KSRC:=no
endif

CHECKSTACK=$(KSRC)/scripts/checkstack.pl

# Set HOTPLUG_FIRMWARE=no to override automatic building with hotplug support
# if it is enabled in the kernel.

ifeq (yes,$(HAS_KSRC))
  HOTPLUG_FIRMWARE:=$(shell if grep -q '^CONFIG_FW_LOADER=[ym]' $(KCONFIG); then echo "yes"; else echo "no"; fi)
endif

UDEV_DIR:=/etc/udev/rules.d

MODULE_ALIASES:=wcfxs wctdm8xxp wct2xxp

INST_HEADERS:=kernel.h user.h fasthdlc.h wctdm_user.h dahdi_config.h

DAHDI_BUILD_ALL:=m

KMAKE=+$(MAKE) -C $(KSRC) SUBDIRS=$(PWD)/drivers/dahdi DAHDI_INCLUDE=$(PWD)/include DAHDI_MODULES_EXTRA="$(DAHDI_MODULES_EXTRA)" HOTPLUG_FIRMWARE=$(HOTPLUG_FIRMWARE)

ROOT_PREFIX:=

ASCIIDOC:=asciidoc
ASCIIDOC_CMD:=$(ASCIIDOC) -n -a toc -a toclevels=4

GENERATED_DOCS:=README.html

ifneq ($(wildcard .version),)
  DAHDIVERSION:=$(shell cat .version)
else
ifneq ($(wildcard .svn),)
  DAHDIVERSION:=$(shell build_tools/make_version . dahdi/linux)
else
ifneq ($(wildcard .git),)
  DAHDIVERSION:=$(shell build_tools/make_version . dahdi/linux)
endif
endif
endif

all: modules

modules: prereq
ifeq (no,$(HAS_KSRC))
	@echo "You do not appear to have the sources for the $(KVERS) kernel installed."
	@exit 1
endif
	$(KMAKE) modules DAHDI_BUILD_ALL=$(DAHDI_BUILD_ALL)

include/dahdi/version.h: FORCE
	@DAHDIVERSION="${DAHDIVERSION}" build_tools/make_version_h > $@.tmp
	@if cmp -s $@.tmp $@ ; then :; else \
		mv $@.tmp $@ ; \
	fi
	@rm -f $@.tmp

prereq: include/dahdi/version.h firmware-loaders

stackcheck: $(CHECKSTACK) modules
	objdump -d drivers/dahdi/*.ko drivers/dahdi/*/*.ko | $(CHECKSTACK)

install: all install-modules install-devices install-include install-firmware install-xpp-firm
	@echo "###################################################"
	@echo "###"
	@echo "### DAHDI installed successfully."
	@echo "### If you have not done so before, install the package"
	@echo "### dahdi-tools."
	@echo "###"
	@echo "###################################################"

uninstall: uninstall-modules uninstall-devices uninstall-include uninstall-firmware

install-modconf:
	build_tools/genmodconf $(BUILDVER) "$(ROOT_PREFIX)" "$(filter-out dahdi dahdi_dummy xpp dahdi_transcode dahdi_dynamic,$(BUILD_MODULES)) $(MODULE_ALIASES)"
	@if [ -d /etc/modutils ]; then \
		/sbin/update-modules ; \
	fi

install-xpp-firm:
	$(MAKE) -C drivers/dahdi/xpp/firmwares install

install-firmware:
ifeq ($(HOTPLUG_FIRMWARE),yes)
	$(MAKE) -C drivers/dahdi/firmware hotplug-install DESTDIR=$(DESTDIR) HOTPLUG_FIRMWARE=$(HOTPLUG_FIRMWARE)
endif

uninstall-firmware:
	$(MAKE) -C drivers/dahdi/firmware hotplug-uninstall DESTDIR=$(DESTDIR)

firmware-loaders:
	$(MAKE) -C drivers/dahdi/firmware firmware-loaders

install-include:
	for hdr in $(INST_HEADERS); do \
		install -D -m 644 include/dahdi/$$hdr $(DESTDIR)/usr/include/dahdi/$$hdr; \
	done
	@rm -rf $(DESTDIR)/usr/include/zaptel

uninstall-include:
	for hdr in $(INST_HEADERS); do \
		rm -f $(DESTDIR)/usr/include/dahdi/$$hdr; \
	done
	-rmdir $(DESTDIR)/usr/include/dahdi

install-devices:
	install -d $(DESTDIR)$(UDEV_DIR)
	build_tools/genudevrules > $(DESTDIR)$(UDEV_DIR)/dahdi.rules
	install -m 644 drivers/dahdi/xpp/xpp.rules $(DESTDIR)$(UDEV_DIR)/

uninstall-devices:
	rm -f $(DESTDIR)$(UDEV_DIR)/dahdi.rules

install-modules: modules
ifndef DESTDIR
	@if modinfo zaptel > /dev/null 2>&1; then \
		echo -n "Removing Zaptel modules for kernel $(KVERS), please wait..."; \
		build_tools/uninstall-modules zaptel $(KVERS); \
		rm -rf /lib/modules/$(KVERS)/zaptel; \
		echo "done."; \
	fi
	build_tools/uninstall-modules dahdi $(KVERS)
endif
	$(KMAKE) INSTALL_MOD_PATH=$(DESTDIR) INSTALL_MOD_DIR=dahdi modules_install
	[ `id -u` = 0 ] && /sbin/depmod -a $(KVERS) || :

uninstall-modules:
ifdef DESTDIR
	@echo "Uninstalling modules is not supported with a DESTDIR specified."
	@exit 1
else
	@if modinfo dahdi > /dev/null 2>&1 ; then \
		echo -n "Removing DAHDI modules for kernel $(KVERS), please wait..."; \
		build_tools/uninstall-modules dahdi $(KVERS); \
		rm -rf /lib/modules/$(KVERS)/dahdi; \
		echo "done."; \
	fi
	[ `id -u` = 0 ] && /sbin/depmod -a $(KVERS) || :
endif

update:
	@if [ -d .svn ]; then \
		echo "Updating from Subversion..." ; \
		svn update | tee update.out; \
		rm -f .version; \
		if [ `grep -c ^C update.out` -gt 0 ]; then \
			echo ; echo "The following files have conflicts:" ; \
			grep ^C update.out | cut -b4- ; \
		fi ; \
		rm -f update.out; \
	else \
		echo "Not under version control";  \
	fi

clean:
ifneq (no,$(HAS_KSRC))
	$(KMAKE) clean
endif
	@rm -f $(GENERATED_DOCS)
	$(MAKE) -C drivers/dahdi/firmware clean

distclean: dist-clean

dist-clean: clean
	@rm -f include/dahdi/version.h
	@$(MAKE) -C drivers/dahdi/firmware dist-clean
	@rm -f drivers/dahdi/vpmadt032_loader/*.o_shipped

firmware-download:
	@$(MAKE) -C drivers/dahdi/firmware all

test:
	./test-script $(DESTDIR)/lib/modules/$(KVERS) dahdi

docs: $(GENERATED_DOCS)

README.html: README
	$(ASCIIDOC_CMD) -o $@ $<

dahdi-api.html: drivers/dahdi/dahdi-base.c
	build_tools/kernel-doc --kernel $(KSRC) $^ >$@

.PHONY: distclean dist-clean clean all install devices modules stackcheck install-udev update install-modules install-include uninstall-modules firmware-download install-xpp-firm firmware-loaders

FORCE:

=== drivers/dahdi/Makefile ===
ifdef KBUILD_EXTMOD
# We only get here on kernels 2.6.0-2.6.9 .
# For newer kernels, Kbuild will be included directly by the kernel
# build system.
include $(src)/Kbuild
endif

=== drivers/dahdi/firmware/Makefile ===
#
# DAHDI
# 
# Makefile for firmware downloading/installation
#
# Copyright (C) 2007-2010, Digium, Inc.
#
# Joshua Colp <jcolp@digium.com>
#
#
# See http://www.asterisk.org for more information about
# the Asterisk project. Please do not directly contact
# any of the maintainers of this project for assistance;
# the project provides a web site, mailing lists and IRC
# channels for your use.
#
# This program is free software, distributed under the terms of
# the GNU General Public License Version 2 as published by the
# Free Software Foundation. See the LICENSE file included with
# this program for more details.
#

.PHONY: dist-clean clean all uninstall have_download install object-build hotplug-install hotplug-dirs hotplug-uninstall make_firmware_object firmware-loaders

OCT6114_064_VERSION:=1.05.01
OCT6114_128_VERSION:=1.05.01
TC400M_VERSION:=MR6.12
VPMADT032_VERSION:=1.25.0
HX8_VERSION:=2.06
VPMOCT032_VERSION:=1.11.0

FIRMWARE_URL:=http://downloads.digium.com/pub/telephony/firmware/releases

ALL_FIRMWARE=FIRMWARE-OCT6114-064 FIRMWARE-OCT6114-128 FIRMWARE-TC400M FIRMWARE-HX8 FIRMWARE-VPMOCT032

# Firmware files should use the naming convention: dahdi-fw-<base name>-<sub name>-<version> or dahdi-fw-<base name>-<version>
# First example: dahdi-fw-oct6114-064-1.05.01
# This means this is version 1.05.01 of the oct6114-064 firmware
# Second example: dahdi-fw-tc400m-MR5.6
# This means this is version MR5.6 of the tc400m firmware

# Build a list of firmware package filenames we need
FIRMWARE:=$(ALL_FIRMWARE:FIRMWARE-OCT6114-064=dahdi-fw-oct6114-064-$(OCT6114_064_VERSION).tar.gz)
FIRMWARE:=$(FIRMWARE:FIRMWARE-OCT6114-128=dahdi-fw-oct6114-128-$(OCT6114_128_VERSION).tar.gz)
FIRMWARE:=$(FIRMWARE:FIRMWARE-TC400M=dahdi-fw-tc400m-$(TC400M_VERSION).tar.gz)
FIRMWARE:=$(FIRMWARE:FIRMWARE-HX8=dahdi-fw-hx8-$(HX8_VERSION).tar.gz)
FIRMWARE:=$(FIRMWARE:FIRMWARE-VPMOCT032=dahdi-fw-vpmoct032-$(VPMOCT032_VERSION).tar.gz)

FWLOADERS:=dahdi-fwload-vpmadt032-$(VPMADT032_VERSION).tar.gz

# Build a list of object files if hotplug will not be used
OBJECT_FILES:=$(ALL_FIRMWARE:FIRMWARE-OCT6114-064=dahdi-fw-oct6114-064.o)
OBJECT_FILES:=$(OBJECT_FILES:FIRMWARE-OCT6114-128=dahdi-fw-oct6114-128.o)
OBJECT_FILES:=$(OBJECT_FILES:FIRMWARE-TC400M=dahdi-fw-tc400m.o)
OBJECT_FILES:=$(OBJECT_FILES:FIRMWARE-HX8=dahdi-fw-hx8.o)

# Force usage of wget, for now
DOWNLOAD=wget
WGET=wget

# If "fetch" is used, --continue is not a valid option.
ifeq ($(WGET),wget)
WGET_ARGS:=--continue
endif

all: $(FIRMWARE)

# Clean up any downloaded/extracted firmware packages
dist-clean: clean
	rm -f dahdi-fw-*.bin
	rm -f dahdi-fw-*.tar.gz
	rm -f dahdi-fwload-*.tar.gz
	rm -f make_firmware_object

# Clean up anything we built
clean:
	rm -f dahdi-fw-*.o

# Download and extract firmware tarballs
dahdi-fw-%.tar.gz:
	@if ( [ "$(HOTPLUG_FIRMWARE)" = "no" ] ) || ( [ -d $(DESTDIR)/usr/lib/hotplug/firmware ] && ! [ -f $(DESTDIR)/usr/lib/hotplug/firmware/.$(subst .tar.gz,,$*) ] ) || ( [ -d $(DESTDIR)/lib/firmware ] && ! [ -f $(DESTDIR)/lib/firmware/.$(subst .tar.gz,,$*) ] ); then \
		echo "Attempting to download $@"; \
		if test ! -f $@; then $(DOWNLOAD) $(WGET_ARGS) $(FIRMWARE_URL)/$@; fi; \
		if test ! -f $@; then exit 1; fi; \
		(cat $@ | gzip -d | tar --no-same-owner -xf -) \
	fi

firmware-loaders: $(FWLOADERS)

.PHONY: dahdi-fwload-vpmadt032-$(VPMADT032_VERSION).tar.gz
dahdi-fwload-vpmadt032-$(VPMADT032_VERSION).tar.gz:
	@if test ! -f $@; then echo "Attempting to download $@"; $(DOWNLOAD) $(WGET_ARGS) $(FIRMWARE_URL)/$@; fi; \
	if test ! -f $@; then exit 1; fi; \
	(cd ../../..; cat drivers/dahdi/firmware/$@ | gzip -d | tar --no-same-owner -xf -)

# Create object files suitable for linking against
object-build: $(FIRMWARE) $(OBJECT_FILES)

$(DESTDIR)/usr/lib/hotplug/firmware $(DESTDIR)/lib/firmware:
	mkdir -p $@

# Install all downloaded firmware images for hotplug usage
hotplug-install: $(DESTDIR)/usr/lib/hotplug/firmware $(DESTDIR)/lib/firmware $(FIRMWARE)
ifeq ($(shell if ( [ -f $(DESTDIR)/usr/lib/hotplug/firmware/.dahdi-fw-oct6114-064-$(OCT6114_064_VERSION) ] ) && ( [ -f $(DESTDIR)/lib/firmware/.dahdi-fw-oct6114-064-$(OCT6114_064_VERSION) ] ); then echo "no"; else echo "yes"; fi),yes)
	@echo "Installing dahdi-fw-oct6114-064.bin to hotplug firmware directories"
	@install -m 644 dahdi-fw-oct6114-064.bin $(DESTDIR)/usr/lib/hotplug/firmware
	@rm -rf $(DESTDIR)/usr/lib/hotplug/firmware/.dahdi-fw-oct6114-064-*
	@touch $(DESTDIR)/usr/lib/hotplug/firmware/.dahdi-fw-oct6114-064-$(OCT6114_064_VERSION)
	@install -m 644 dahdi-fw-oct6114-064.bin $(DESTDIR)/lib/firmware
	@rm -rf $(DESTDIR)/lib/firmware/.dahdi-fw-oct6114-064-*
	@touch $(DESTDIR)/lib/firmware/.dahdi-fw-oct6114-064-$(OCT6114_064_VERSION)
else
	@echo "Firmware dahdi-fw-oct6114-064.bin is already installed with required version $(OCT6114_064_VERSION)"
endif
ifeq ($(shell if ( [ -f $(DESTDIR)/usr/lib/hotplug/firmware/.dahdi-fw-oct6114-128-$(OCT6114_128_VERSION) ] ) && ( [ -f $(DESTDIR)/lib/firmware/.dahdi-fw-oct6114-128-$(OCT6114_128_VERSION) ] ); then echo "no"; else echo "yes"; fi),yes)
	@echo "Installing dahdi-fw-oct6114-128.bin to hotplug firmware directories"
	@install -m 644 dahdi-fw-oct6114-128.bin $(DESTDIR)/usr/lib/hotplug/firmware
	@rm -rf $(DESTDIR)/usr/lib/hotplug/firmware/.dahdi-fw-oct6114-128-*
	@touch $(DESTDIR)/usr/lib/hotplug/firmware/.dahdi-fw-oct6114-128-$(OCT6114_128_VERSION)
	@install -m 644 dahdi-fw-oct6114-128.bin $(DESTDIR)/lib/firmware
	@rm -rf $(DESTDIR)/lib/firmware/.dahdi-fw-oct6114-128-*
	@touch $(DESTDIR)/lib/firmware/.dahdi-fw-oct6114-128-$(OCT6114_128_VERSION)
else
	@echo "Firmware dahdi-fw-oct6114-128.bin is already installed with required version $(OCT6114_128_VERSION)"
endif
ifeq ($(shell if ( [ -f $(DESTDIR)/usr/lib/hotplug/firmware/.dahdi-fw-tc400m-$(TC400M_VERSION) ] ) && ( [ -f $(DESTDIR)/lib/firmware/.dahdi-fw-tc400m-$(TC400M_VERSION) ] ); then echo "no"; else echo "yes"; fi),yes)
	@echo "Installing dahdi-fw-tc400m.bin to hotplug firmware directories"
	@install -m 644 dahdi-fw-tc400m.bin $(DESTDIR)/usr/lib/hotplug/firmware
	@rm -rf $(DESTDIR)/usr/lib/hotplug/firmware/.dahdi-fw-tc400m-*
	@touch $(DESTDIR)/usr/lib/hotplug/firmware/.dahdi-fw-tc400m-$(TC400M_VERSION)
	@install -m 644 dahdi-fw-tc400m.bin $(DESTDIR)/lib/firmware
	@rm -rf $(DESTDIR)/lib/firmware/.dahdi-fw-tc400m-*
	@touch $(DESTDIR)/lib/firmware/.dahdi-fw-tc400m-$(TC400M_VERSION)
else
	@echo "Firmware dahdi-fw-tc400m.bin is already installed with required version $(TC400M_VERSION)"
endif
ifeq ($(shell if ( [ -f $(DESTDIR)/usr/lib/hotplug/firmware/.dahdi-fw-hx8-$(HX8_VERSION) ] ) && ( [ -f $(DESTDIR)/lib/firmware/.dahdi-fw-hx8-$(HX8_VERSION) ] ); then echo "no"; else echo "yes"; fi),yes)
	@echo "Installing dahdi-fw-hx8.bin to hotplug firmware directories"
	@install -m 644 dahdi-fw-hx8.bin $(DESTDIR)/usr/lib/hotplug/firmware
	@rm -rf $(DESTDIR)/usr/lib/hotplug/firmware/.dahdi-fw-hx8-*
	@touch $(DESTDIR)/usr/lib/hotplug/firmware/.dahdi-fw-hx8-$(HX8_VERSION)
	@install -m 644 dahdi-fw-hx8.bin $(DESTDIR)/lib/firmware
	@rm -rf $(DESTDIR)/lib/firmware/.dahdi-fw-hx8-*
	@touch $(DESTDIR)/lib/firmware/.dahdi-fw-hx8-$(HX8_VERSION)
else
	@echo "Firmware dahdi-fw-hx8.bin is already installed with required version $(HX8_VERSION)"
endif
ifeq ($(shell if ( [ -f $(DESTDIR)/usr/lib/hotplug/firmware/.dahdi-fw-vpmoct032-$(VPMOCT032_VERSION) ] ) && ( [ -f $(DESTDIR)/lib/firmware/.dahdi-fw-vpmoct032-$(VPMOCT032_VERSION) ] ); then echo "no"; else echo "yes"; fi),yes)
	@echo "Installing dahdi-fw-vpmoct032.bin to hotplug firmware directories"
	@install -m 644 dahdi-fw-vpmoct032.bin $(DESTDIR)/usr/lib/hotplug/firmware
	@rm -rf $(DESTDIR)/usr/lib/hotplug/firmware/.dahdi-fw-vpmoct032-*
	@touch $(DESTDIR)/usr/lib/hotplug/firmware/.dahdi-fw-vpmoct032-$(VPMOCT032_VERSION)
	@install -m 644 dahdi-fw-vpmoct032.bin $(DESTDIR)/lib/firmware
	@rm -rf $(DESTDIR)/lib/firmware/.dahdi-fw-vpmoct032-*
	@touch $(DESTDIR)/lib/firmware/.dahdi-fw-vpmoct032-$(VPMOCT032_VERSION)
else
	@echo "Firmware dahdi-fw-vpmoct032.bin is already installed with required version $(VPMOCT032_VERSION)"
endif

# Uninstall any installed dahdi firmware images from hotplug firmware directories
hotplug-uninstall:
	if [ -d $(DESTDIR)/usr/lib/hotplug/firmware ]; then \
		rm -f $(DESTDIR)/usr/lib/hotplug/firmware/dahdi-fw-*.bin; \
		rm -f $(DESTDIR)/usr/lib/hotplug/firmware/.dahdi-fw*; \
	fi
	if [ -d $(DESTDIR)/lib/firmware ]; then \
		rm -f $(DESTDIR)/lib/firmware/dahdi-fw-*.bin; \
		rm -f $(DESTDIR)/lib/firmware/.dahdi-fw*; \
	fi

make_firmware_object: make_firmware_object.in ../dahdi-base.o
	@export BFDNAME=`LANG=C objdump -f ../dahdi-base.o | grep -e "dahdi-base.o:" | sed "s/.*file format \(.*\)/\1/"`; \
	 export BFDARCH=`LANG=C objdump -f ../dahdi-base.o | grep -e "architecture:" | sed "s/.*ture: \(.*\),.*/\1/"`; \
	 sed -e s/BFDNAME/$${BFDNAME}/ -e s/BFDARCH/$${BFDARCH}/ $< > $@
	@chmod +x $@

# Build object file of an oct6114 064 firmware image for linking
dahdi-fw-oct6114-064.o: dahdi-fw-oct6114-064-$(OCT6114_064_VERSION).tar.gz dahdi-fw-oct6114-064.bin make_firmware_object
	@echo Making firmware object file for dahdi-fw-oct6114-064.bin
	./make_firmware_object dahdi-fw-oct6114-064.bin $@

# Build object file of an oct6114 128 firmware image for linking
dahdi-fw-oct6114-128.o: dahdi-fw-oct6114-128-$(OCT6114_128_VERSION).tar.gz dahdi-fw-oct6114-128.bin make_firmware_object
	@echo Making firmware object file for dahdi-fw-oct6114-128.bin
	./make_firmware_object dahdi-fw-oct6114-128.bin $@

# Build object file of a TC400M firmware image for linking
dahdi-fw-tc400m.o: dahdi-fw-tc400m-$(TC400M_VERSION).tar.gz dahdi-fw-tc400m.bin make_firmware_object
	@echo Making firmware object file for dahdi-fw-tc400m.bin
	./make_firmware_object dahdi-fw-tc400m.bin $@

=== drivers/dahdi/wcb4xxp/Makefile ===
ifdef KBUILD_EXTMOD
# We only get here on kernels 2.6.0-2.6.9 .
# For newer kernels, Kbuild will be included directly by the kernel
# build system.
include $(src)/Kbuild
else
endif

=== drivers/dahdi/wct4xxp/Makefile ===
ifdef KBUILD_EXTMOD
# We only get here on kernels 2.6.0-2.6.9 .
# For newer kernels, Kbuild will be included directly by the kernel
# build system.
include $(src)/Kbuild

else
endif

=== drivers/dahdi/xpp/firmwares/Makefile ===
# Install firmwares and initialization scripts for the Astribank
# drivers

FPGA_FW		= FPGA_FXS.hex FPGA_1141.hex FPGA_1151.hex FPGA_1161.hex
PIC_FW		= PIC_TYPE_1.hex PIC_TYPE_2.hex PIC_TYPE_3.hex PIC_TYPE_4.hex  
OCT_FW		= $(wildcard OCT6104E-256D.ima)
FIRMWARES	= USB_FW.hex $(FPGA_FW) $(PIC_FW) $(OCT_FW)
PROTO_VER	= 30
SCRIPTS_BASE	= $(patsubst %,init_card_%_$(PROTO_VER),1 2 3 4 5)
SCRIPTS		= $(SCRIPTS_BASE:%=../%)
TARGET		= $(DESTDIR)/usr/share/dahdi

all:

clean:

install:
	mkdir -p $(TARGET)
	install $(SCRIPTS) $(TARGET)/
	install -m 644 ../XppConfig.pm $(FIRMWARES) $(TARGET)/

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export HOTPLUG_FIRMWARE=1

ifneq (,$(findstring debug,$(DEB_BUILD_OPTIONS)))
	CFLAGS += -g
endif

## MODULE-ASSISTANT STUFF
# prefix of the target package name
PREFIX:=dahdi
SKPG:=$(PREFIX)-source
PACKAGE:=$(PREFIX)-modules
PACKAGE_SRC:=$(PREFIX)-linux
# modifieable for experiments or debugging m-a
MA_DIR ?= /usr/share/modass
# load generic variable handling
-include $(MA_DIR)/include/generic.make
# load default rules
-include $(MA_DIR)/include/common-rules.make

DEBVERSION:=$(shell head -n 1 debian/changelog \
		    | sed -e 's/^[^(]*(\([^)]*\)).*/\1/')
DEB_BASE_VERSION:=$(shell echo $(DEBVERSION) | sed -e 's/^.*://' -e 's/-[0-9~.a-z]*$$//')
UPVERSION:=$(shell echo $(DEB_BASE_VERSION) | sed -e 's/[~+]dfsg\(~\|$$\)/\1/' -e 's/~\(rc\|beta\)/-\1/')

# For DKMS. Use the full release (e.g.: 2.2.1+dfsg-1ubuntu1)
CVERSION := $(shell dpkg-parsechangelog | grep '^Version:' | cut -d' ' -f2 | cut -d\: -f2)

UPFILENAME := $(PACKAGE_SRC)_$(UPVERSION).orig.tar.gz
FILENAME := $(PACKAGE_SRC)_$(DEB_BASE_VERSION).orig.tar.gz
URL := http://downloads.asterisk.org/pub/telephony/$(PACKAGE_SRC)/releases/$(PACKAGE_SRC)-$(UPVERSION).tar.gz

# If the makefile was properly-writen, there was a good separation 
# between kernel and userspace. As things stand now I'd like to work
# around problems with bilding stuff with HOSTCC by simply providing 
# the generated headers as part of the source:
GENERATED_SOURCES := include/dahdi/version.h

EXTRA_MODS=dahdi_echocan_oslec
EXTRA_SUBDIRS = ap400 opvxa1200 opvxd115 zaphfc ../staging/echo

ifneq (,$(filter-out powerpc m68k armeb mips,$(shell dpkg-architecture -qDEB_HOST_ARCH)))
EXTRA_MODS += wcopenpci
endif

MOD_ARGS=MODULES_EXTRA="$(EXTRA_MODS)" SUBDIRS_EXTRA="$(EXTRA_SUBDIRS)"

%:
	dh $@

kdist_clean: clean

kdist_config: prep-deb-files

binary-modules: prep-deb-files
	dh_testdir
	dh_testroot
	dh_prep
	#cp -a $(CURDIR)/debian/generated/* .
	make $(MOD_ARGS) modules KERNEL_SOURCES=$(KSRC) MODVERSIONS=detect KERNEL=linux-$(KVERS) 
	make $(MOD_ARGS) install-modules KERNELRELEASE=$(KVERS) DESTDIR=$(CURDIR)/debian/$(PKGNAME)
ifeq (2.6,$(shell echo $(KVERS) | cut -d. -f1-2))
	# The 2.6 modules are way too big. This is only in kernel 2.6
	find debian/$(PKGNAME)/lib/modules -name '*.ko' |xargs strip -g
	$(RM) -f debian/$(PKGNAME)/lib/modules/$(KVERS)/modules.*
endif
	dh_installmodules
	dh_installdebconf
	dh_installdocs
	dh_installchangelogs
	dh_compress
	dh_fixperms
	dh_installdeb
	dh_gencontrol -- -v$(VERSION)
	dh_md5sums
	dh_builddeb --destdir=$(DEB_DESTDIR)

## END OF M-A SECTION

override_dh_auto_build:

	# For DKMS
	sed -e "s|#CVERSION#|$(CVERSION)|"   \
		debian/dkms.conf.in > debian/dkms.conf
	sed -e "s|#CVERSION#|$(CVERSION)|"   \
		debian/dahdi-dkms.install.in > debian/dahdi-dkms.install

	$(MAKE) docs
	$(MAKE) $(GENERATED_SOURCES)

override_dh_auto_clean:
	#Delete the generated dkms files
	rm -f debian/dahdi-dkms.install
	rm -f debian/dkms.conf
	rm -f $(GENERATED_SOURCES)
	rm -f dahdi/include/version.h
	[ ! -f Makefile ] || $(MAKE) dist-clean || true

TARPARDIR=$(CURDIR)/debian/tmp
TARDIR=$(TARPARDIR)/modules/$(PREFIX)

override_dh_auto_install:
	$(MAKE) install-include DESTDIR=$(CURDIR)/debian/$(SKPG)

override_dh_install:
	dh_install
	# driver source code
	mkdir -p $(TARDIR)/debian/generated
	cp Makefile $(TARDIR)/
	cp -p .version $(TARDIR)/
	for dir in build_tools firmware include drivers; do \
	  if [ -d $$dir ]; then cp -r $$dir $(TARDIR); fi; \
	done
	
	# Packaging infrastructure
	cp -r debian/rules debian/changelog debian/copyright\
	  debian/control debian/compat \
	  debian/control.modules.in \
	  $(TARDIR)/debian/
	
	tar cjf debian/$(SKPG)/usr/src/$(PREFIX).tar.bz2 \
	  -C $(TARPARDIR) modules

print-version:
	@@echo "Debian version:          $(DEBVERSION)"
	@@echo "Upstream version:        $(UPVERSION)"

TARBALL_DIR=../tarballs/$(PACKAGE_SRC)-$(UPVERSION).tmp
get-orig-source:
	@@dh_testdir
	@@[ -d ../tarballs/. ]||mkdir -p ../tarballs
	@@echo Downloading $(UPFILENAME) from $(URL) ...
	@@wget  -nv -T10 -t3 --verbose -O ../tarballs/$(UPFILENAME) $(URL)
	@@echo Repacking as DFSG-free...
	@@mkdir -p $(TARBALL_DIR)/
	@@cd $(TARBALL_DIR) ; \
	tar xfz ../$(UPFILENAME)
	@@rm -rf $(TARBALL_DIR)/$(PACKAGE_SRC)-$(UPVERSION)/drivers/dahdi/xpp/firmwares/*.hex
	@@cd $(TARBALL_DIR) ; \
	tar cfz ../$(FILENAME) *
	@@echo Cleaning up...
	@@$(RM) -rf $(TARBALL_DIR)/
	@@$(RM) -f ../tarballs/$(UPFILENAME)

## dahdi-linux 2.6.1+dfsg2

=== drivers/dahdi/firmware/Makefile ===
--- 
+++ 
@@ -24,14 +24,16 @@
 
 OCT6114_064_VERSION:=1.05.01
 OCT6114_128_VERSION:=1.05.01
+OCT6114_256_VERSION:=1.05.01
 TC400M_VERSION:=MR6.12
 VPMADT032_VERSION:=1.25.0
 HX8_VERSION:=2.06
-VPMOCT032_VERSION:=1.11.0
+VPMOCT032_VERSION:=1.12.0
+WCT820_VERSION:=1.76
 
 FIRMWARE_URL:=http://downloads.digium.com/pub/telephony/firmware/releases
 
-ALL_FIRMWARE=FIRMWARE-OCT6114-064 FIRMWARE-OCT6114-128 FIRMWARE-TC400M FIRMWARE-HX8 FIRMWARE-VPMOCT032
+ALL_FIRMWARE=FIRMWARE-OCT6114-064 FIRMWARE-OCT6114-128 FIRMWARE-OCT6114-256 FIRMWARE-TC400M FIRMWARE-HX8 FIRMWARE-VPMOCT032 FIRMWARE-TE820
 
 # Firmware files should use the naming convention: dahdi-fw-<base name>-<sub name>-<version> or dahdi-fw-<base name>-<version>
 # First example: dahdi-fw-oct6114-064-1.05.01
@@ -42,17 +44,21 @@
 # Build a list of firmware package filenames we need
 FIRMWARE:=$(ALL_FIRMWARE:FIRMWARE-OCT6114-064=dahdi-fw-oct6114-064-$(OCT6114_064_VERSION).tar.gz)
 FIRMWARE:=$(FIRMWARE:FIRMWARE-OCT6114-128=dahdi-fw-oct6114-128-$(OCT6114_128_VERSION).tar.gz)
+FIRMWARE:=$(FIRMWARE:FIRMWARE-OCT6114-256=dahdi-fw-oct6114-256-$(OCT6114_256_VERSION).tar.gz)
 FIRMWARE:=$(FIRMWARE:FIRMWARE-TC400M=dahdi-fw-tc400m-$(TC400M_VERSION).tar.gz)
 FIRMWARE:=$(FIRMWARE:FIRMWARE-HX8=dahdi-fw-hx8-$(HX8_VERSION).tar.gz)
 FIRMWARE:=$(FIRMWARE:FIRMWARE-VPMOCT032=dahdi-fw-vpmoct032-$(VPMOCT032_VERSION).tar.gz)
+FIRMWARE:=$(FIRMWARE:FIRMWARE-TE820=dahdi-fw-te820-$(WCT820_VERSION).tar.gz)
 
 FWLOADERS:=dahdi-fwload-vpmadt032-$(VPMADT032_VERSION).tar.gz
 
 # Build a list of object files if hotplug will not be used
 OBJECT_FILES:=$(ALL_FIRMWARE:FIRMWARE-OCT6114-064=dahdi-fw-oct6114-064.o)
 OBJECT_FILES:=$(OBJECT_FILES:FIRMWARE-OCT6114-128=dahdi-fw-oct6114-128.o)
+OBJECT_FILES:=$(OBJECT_FILES:FIRMWARE-OCT6114-256=dahdi-fw-oct6114-256.o)
 OBJECT_FILES:=$(OBJECT_FILES:FIRMWARE-TC400M=dahdi-fw-tc400m.o)
 OBJECT_FILES:=$(OBJECT_FILES:FIRMWARE-HX8=dahdi-fw-hx8.o)
+OBJECT_FILES:=$(OBJECT_FILES:FIRMWARE-VPMOCT032=dahdi-fw-vpmoct032.o)
 
 # Force usage of wget, for now
 DOWNLOAD=wget
@@ -123,6 +129,17 @@
 else
 	@echo "Firmware dahdi-fw-oct6114-128.bin is already installed with required version $(OCT6114_128_VERSION)"
 endif
+ifeq ($(shell if ( [ -f $(DESTDIR)/usr/lib/hotplug/firmware/.dahdi-fw-oct6114-256-$(OCT6114_256_VERSION) ] ) && ( [ -f $(DESTDIR)/lib/firmware/.dahdi-fw-oct6114-256-$(OCT6114_256_VERSION) ] ); then echo "no"; else echo "yes"; fi),yes)
+	@echo "Installing dahdi-fw-oct6114-256.bin to hotplug firmware directories"
+	@install -m 644 dahdi-fw-oct6114-256.bin $(DESTDIR)/usr/lib/hotplug/firmware
+	@rm -rf $(DESTDIR)/usr/lib/hotplug/firmware/.dahdi-fw-oct6114-256-*
+	@touch $(DESTDIR)/usr/lib/hotplug/firmware/.dahdi-fw-oct6114-256-$(OCT6114_256_VERSION)
+	@install -m 644 dahdi-fw-oct6114-256.bin $(DESTDIR)/lib/firmware
+	@rm -rf $(DESTDIR)/lib/firmware/.dahdi-fw-oct6114-256-*
+	@touch $(DESTDIR)/lib/firmware/.dahdi-fw-oct6114-256-$(OCT6114_256_VERSION)
+else
+	@echo "Firmware dahdi-fw-oct6114-256.bin is already installed with required version $(OCT6114_256_VERSION)"
+endif
 ifeq ($(shell if ( [ -f $(DESTDIR)/usr/lib/hotplug/firmware/.dahdi-fw-tc400m-$(TC400M_VERSION) ] ) && ( [ -f $(DESTDIR)/lib/firmware/.dahdi-fw-tc400m-$(TC400M_VERSION) ] ); then echo "no"; else echo "yes"; fi),yes)
 	@echo "Installing dahdi-fw-tc400m.bin to hotplug firmware directories"
 	@install -m 644 dahdi-fw-tc400m.bin $(DESTDIR)/usr/lib/hotplug/firmware
@@ -155,6 +172,17 @@
 	@touch $(DESTDIR)/lib/firmware/.dahdi-fw-vpmoct032-$(VPMOCT032_VERSION)
 else
 	@echo "Firmware dahdi-fw-vpmoct032.bin is already installed with required version $(VPMOCT032_VERSION)"
+endif
+ifeq ($(shell if ( [ -f $(DESTDIR)/usr/lib/hotplug/firmware/.dahdi-fw-te820-$(WCT820_VERSION) ] ) && ( [ -f $(DESTDIR)/lib/firmware/.dahdi-fw-te820-$(WCT820_VERSION) ] ); then echo "no"; else echo "yes"; fi),yes)
+	@echo "Installing dahdi-fw-te820.bin to hotplug firmware directories"
+	@install -m 644 dahdi-fw-te820.bin $(DESTDIR)/usr/lib/hotplug/firmware
+	@rm -rf $(DESTDIR)/usr/lib/hotplug/firmware/.dahdi-fw-te820-*
+	@touch $(DESTDIR)/usr/lib/hotplug/firmware/.dahdi-fw-te820-$(WCT820_VERSION)
+	@install -m 644 dahdi-fw-te820.bin $(DESTDIR)/lib/firmware
+	@rm -rf $(DESTDIR)/lib/firmware/.dahdi-fw-te820-*
+	@touch $(DESTDIR)/lib/firmware/.dahdi-fw-te820-$(WCT820_VERSION)
+else
+	@echo "Firmware dahdi-fw-te820.bin is already installed with required version $(WCT820_VERSION)"
 endif
 
 # Uninstall any installed dahdi firmware images from hotplug firmware directories
@@ -184,7 +212,10 @@
 	@echo Making firmware object file for dahdi-fw-oct6114-128.bin
 	./make_firmware_object dahdi-fw-oct6114-128.bin $@
 
+# Build object file of an oct6114 256 firmware image for linking
+dahdi-fw-oct6114-256.o: dahdi-fw-oct6114-256-$(OCT6114_256_VERSION).tar.gz dahdi-fw-oct6114-256.bin make_firmware_object
+	@echo Making firmware object file for dahdi-fw-oct6114-256.bin
+	./make_firmware_object dahdi-fw-oct6114-256.bin $@
+
 # Build object file of a TC400M firmware image for linking
 dahdi-fw-tc400m.o: dahdi-fw-tc400m-$(TC400M_VERSION).tar.gz dahdi-fw-tc400m.bin make_firmware_object
-	@echo Making firmware object file for dahdi-fw-tc400m.bin
-	./make_firmware_object dahdi-fw-tc400m.bin $@

=== drivers/dahdi/xpp/firmwares/Makefile ===
--- 
+++ 
@@ -1,10 +1,12 @@
 # Install firmwares and initialization scripts for the Astribank
 # drivers
 
-FPGA_FW		= FPGA_FXS.hex FPGA_1141.hex FPGA_1151.hex FPGA_1161.hex
+USB_FW		= USB_FW.hex USB_FW.201.hex USB_RECOV.hex
+FPGA_FW		= FPGA_FXS.hex FPGA_1141.hex FPGA_1151.hex FPGA_1161.hex  \
+		  FPGA_1161.201.hex
 PIC_FW		= PIC_TYPE_1.hex PIC_TYPE_2.hex PIC_TYPE_3.hex PIC_TYPE_4.hex  
 OCT_FW		= $(wildcard OCT6104E-256D.ima)
-FIRMWARES	= USB_FW.hex $(FPGA_FW) $(PIC_FW) $(OCT_FW)
+FIRMWARES	= $(USB_FW) $(FPGA_FW) $(PIC_FW) $(OCT_FW)
 PROTO_VER	= 30
 SCRIPTS_BASE	= $(patsubst %,init_card_%_$(PROTO_VER),1 2 3 4 5)
 SCRIPTS		= $(SCRIPTS_BASE:%=../%)

=== debian/changelog ===
dahdi-linux (1:2.6.1+dfsg2-1) unstable; urgency=low

  * Patch fix_define_dev: fix building with kernel 3.8.
  * Remove non-free FPGA bitfiles and patch drivers to load them
    (Closes: #693666) (Ben Hutchings).
  * Patch fix_xpp_usermode: fixes odd xpp behaviour with later kernels.
  * Patch fix_xpp_post_unregister: fixes a crash with manual
    'dahdi_registration off'.

 -- Tzafrir Cohen <tzafrir@debian.org>  Wed, 30 Jan 2013 00:18:38 +0200

dahdi-linux (1:2.6.1+dfsg-1) unstable; urgency=low

  * New upstream release candidate:
    - Patch xpp_fix_2fxs6fxo removed: merged upstream.
    - Patch oslec_auto removed: merged upstream.
  * Removed all EXTRA_* build variables:
    - wcopenpci builds on big-endial (sort of).
    - All other logic is set through Kbuild.
  * Don't strip.

 -- Tzafrir Cohen <tzafrir@debian.org>  Mon, 23 Apr 2012 11:05:30 +0300

=== debian/control ===
Source: dahdi-linux
Section: comm
Priority: optional
Maintainer: Debian VoIP Team <pkg-voip-maintainers@lists.alioth.debian.org>
Uploaders: Tzafrir Cohen <tzafrir@debian.org>, Mark Purcell <msp@debian.org>, Faidon Liambotis <paravoid@debian.org>
Build-Depends: debhelper (>=  7.0.50~), bzip2, asciidoc
Standards-Version: 3.9.2
Homepage: http://www.asterisk.org/
Vcs-Svn: svn://svn.debian.org/pkg-voip/dahdi-linux/trunk/
Vcs-Browser: http://svn.debian.org/wsvn/pkg-voip/dahdi-linux/?op=log

Package: dahdi-linux
Architecture: all
# Xorcom packages depend on dahdi-firmware. Debian zaptel will probably 
# just recommend it.
Depends: ${shlibs:Depends}, ${misc:Depends}, procps, fxload
Replaces: zaptel
Conflicts: zaptel
Description: DAHDI telephony interface - Linux userspace parts
 DAHDI (formly Zaptel) is an interface for telephony devices used by e.g. 
 the Asterisk PBX software. The dahdi-* packages provide the kernel 
 DAHDI kernel modules and their required setup environment.
 .
 This package includes the minimal Linux-specific userspace parts: udev 
 configuration, xpp initialization scripts.

Package: dahdi-source
Section: kernel
Architecture: all
Depends: ${misc:Depends}, debhelper (>> 4.0), module-assistant (>= 0.8.1), bzip2
Recommends: dahdi-linux
Description: DAHDI telephony interface - source code for kernel driver
 DAHDI (formly Zaptel) is an interface for telephony devices used by e.g. 
 the Asterisk PBX software. The dahdi-* packages provide the kernel 
 DAHDI kernel modules and their required setup environment, as well as
 basic headers for building DAHDI modules and utilities.
 .
 It is normally used to build kernel modules package: m-a a-i dahdi

=== debian/rules ===
--- 
+++ 
@@ -25,10 +25,7 @@
 DEBVERSION:=$(shell head -n 1 debian/changelog \
 		    | sed -e 's/^[^(]*(\([^)]*\)).*/\1/')
 DEB_BASE_VERSION:=$(shell echo $(DEBVERSION) | sed -e 's/^.*://' -e 's/-[0-9~.a-z]*$$//')
-UPVERSION:=$(shell echo $(DEB_BASE_VERSION) | sed -e 's/[~+]dfsg\(~\|$$\)/\1/' -e 's/~\(rc\|beta\)/-\1/')
-
-# For DKMS. Use the full release (e.g.: 2.2.1+dfsg-1ubuntu1)
-CVERSION := $(shell dpkg-parsechangelog | grep '^Version:' | cut -d' ' -f2 | cut -d\: -f2)
+UPVERSION:=$(shell echo $(DEB_BASE_VERSION) | sed -e 's/[~+]dfsg[0-9]*\(~\|$$\)/\1/' -e 's/~\(rc\|beta\)/-\1/')
 
 UPFILENAME := $(PACKAGE_SRC)_$(UPVERSION).orig.tar.gz
 FILENAME := $(PACKAGE_SRC)_$(DEB_BASE_VERSION).orig.tar.gz
@@ -39,15 +36,6 @@
 # around problems with bilding stuff with HOSTCC by simply providing 
 # the generated headers as part of the source:
 GENERATED_SOURCES := include/dahdi/version.h
-
-EXTRA_MODS=dahdi_echocan_oslec
-EXTRA_SUBDIRS = ap400 opvxa1200 opvxd115 zaphfc ../staging/echo
-
-ifneq (,$(filter-out powerpc m68k armeb mips,$(shell dpkg-architecture -qDEB_HOST_ARCH)))
-EXTRA_MODS += wcopenpci
-endif
-
-MOD_ARGS=MODULES_EXTRA="$(EXTRA_MODS)" SUBDIRS_EXTRA="$(EXTRA_SUBDIRS)"
 
 %:
 	dh $@
@@ -61,13 +49,12 @@
 	dh_testroot
 	dh_prep
 	#cp -a $(CURDIR)/debian/generated/* .
-	make $(MOD_ARGS) modules KERNEL_SOURCES=$(KSRC) MODVERSIONS=detect KERNEL=linux-$(KVERS) 
-	make $(MOD_ARGS) install-modules KERNELRELEASE=$(KVERS) DESTDIR=$(CURDIR)/debian/$(PKGNAME)
-ifeq (2.6,$(shell echo $(KVERS) | cut -d. -f1-2))
-	# The 2.6 modules are way too big. This is only in kernel 2.6
-	find debian/$(PKGNAME)/lib/modules -name '*.ko' |xargs strip -g
+	make modules KERNEL_SOURCES=$(KSRC) MODVERSIONS=detect KERNEL=linux-$(KVERS) 
+	make install-modules KERNELRELEASE=$(KVERS) DESTDIR=$(CURDIR)/debian/$(PKGNAME)
+	# The modules are way too big. This is only in kernel 2.6
+	# (Removed for now: breaks cross-building)
+	#find debian/$(PKGNAME)/lib/modules -name '*.ko' |xargs strip -g
 	$(RM) -f debian/$(PKGNAME)/lib/modules/$(KVERS)/modules.*
-endif
 	dh_installmodules
 	dh_installdebconf
 	dh_installdocs
@@ -82,20 +69,10 @@
 ## END OF M-A SECTION
 
 override_dh_auto_build:
-
-	# For DKMS
-	sed -e "s|#CVERSION#|$(CVERSION)|"   \
-		debian/dkms.conf.in > debian/dkms.conf
-	sed -e "s|#CVERSION#|$(CVERSION)|"   \
-		debian/dahdi-dkms.install.in > debian/dahdi-dkms.install
-
 	$(MAKE) docs
 	$(MAKE) $(GENERATED_SOURCES)
 
 override_dh_auto_clean:
-	#Delete the generated dkms files
-	rm -f debian/dahdi-dkms.install
-	rm -f debian/dkms.conf
 	rm -f $(GENERATED_SOURCES)
 	rm -f dahdi/include/version.h
 	[ ! -f Makefile ] || $(MAKE) dist-clean || true
@@ -140,6 +117,7 @@
 	@@cd $(TARBALL_DIR) ; \
 	tar xfz ../$(UPFILENAME)
 	@@rm -rf $(TARBALL_DIR)/$(PACKAGE_SRC)-$(UPVERSION)/drivers/dahdi/xpp/firmwares/*.hex
+	@@rm -f $(TARBALL_DIR)/$(PACKAGE_SRC)-$(UPVERSION)/drivers/dahdi/*.rbt
 	@@cd $(TARBALL_DIR) ; \
 	tar cfz ../$(FILENAME) *
 	@@echo Cleaning up...

## dahdi-linux 2.7.0.1~dfsg

=== Makefile ===
--- 
+++ 
@@ -64,17 +64,7 @@
 
 GENERATED_DOCS:=README.html
 
-ifneq ($(wildcard .version),)
-  DAHDIVERSION:=$(shell cat .version)
-else
-ifneq ($(wildcard .svn),)
-  DAHDIVERSION:=$(shell build_tools/make_version . dahdi/linux)
-else
-ifneq ($(wildcard .git),)
-  DAHDIVERSION:=$(shell build_tools/make_version . dahdi/linux)
-endif
-endif
-endif
+DAHDIVERSION:=$(shell build_tools/make_version . dahdi/linux)
 
 all: modules
 
@@ -92,7 +82,7 @@
 	fi
 	@rm -f $@.tmp
 
-prereq: include/dahdi/version.h firmware-loaders
+prereq: include/dahdi/version.h firmware-loaders oct612x-lib
 
 stackcheck: $(CHECKSTACK) modules
 	objdump -d drivers/dahdi/*.ko drivers/dahdi/*/*.ko | $(CHECKSTACK)
@@ -127,6 +117,13 @@
 
 firmware-loaders:
 	$(MAKE) -C drivers/dahdi/firmware firmware-loaders
+
+oct612x-lib:
+ifeq (no,$(HAS_KSRC))
+	@echo "You do not appear to have the sources for the $(KVERS) kernel installed."
+	@exit 1
+endif
+	$(MAKE) -C $(KSRC) M='$(PWD)/drivers/dahdi/oct612x'
 
 install-include:
 	for hdr in $(INST_HEADERS); do \
@@ -195,6 +192,7 @@
 endif
 	@rm -f $(GENERATED_DOCS)
 	$(MAKE) -C drivers/dahdi/firmware clean
+	$(MAKE) -C $(KSRC) M='$(PWD)/drivers/dahdi/oct612x' clean
 
 distclean: dist-clean

=== debian/changelog ===
dahdi-linux (1:2.7.0.1~dfsg-1) unstable; urgency=low

  * New upstream release
    - Fixes "doorphone device ignored" (Closes: #687970)
  * Update Vcs-Browser - fix vcs-field-bitrotted

 -- Mark Purcell <msp@debian.org>  Sat, 28 Sep 2013 13:16:06 +1000

dahdi-linux (1:2.7.0+dfsg-1) unstable; urgency=low

  [ Tzafrir Cohen ] 
  * New upstream release:
    - Patch fix_define_dev dropped: merged upstream.
    - Patch fix_xpp_usermode dropped: merged upstream.
    - Patch fix_xpp_post_unregister dropped: merged upstream.

 -- Mark Purcell <msp@debian.org>  Sun, 16 Jun 2013 16:49:06 +1000

=== debian/control ===
--- 
+++ 
@@ -4,10 +4,10 @@
 Maintainer: Debian VoIP Team <pkg-voip-maintainers@lists.alioth.debian.org>
 Uploaders: Tzafrir Cohen <tzafrir@debian.org>, Mark Purcell <msp@debian.org>, Faidon Liambotis <paravoid@debian.org>
 Build-Depends: debhelper (>=  7.0.50~), bzip2, asciidoc
-Standards-Version: 3.9.2
+Standards-Version: 3.9.4
 Homepage: http://www.asterisk.org/
 Vcs-Svn: svn://svn.debian.org/pkg-voip/dahdi-linux/trunk/
-Vcs-Browser: http://svn.debian.org/wsvn/pkg-voip/dahdi-linux/?op=log
+Vcs-Browser: http://anonscm.debian.org/viewvc/pkg-voip/dahdi-linux/
 
 Package: dahdi-linux
 Architecture: all

## dahdi-linux 2.10.0.1~dfsg

=== debian/changelog ===
dahdi-linux (1:2.10.0.1~dfsg-1) unstable; urgency=low

  * New upstream release
  * Fix VCS link.

 -- Tzafrir Cohen <tzafrir@debian.org>  Sun, 26 Oct 2014 13:46:19 +0200

dahdi-linux (1:2.10.0~dfsg-1) unstable; urgency=low

  [ Tzafrir Cohen ]
  * New upstream release (Closes: #753660):
    - Patch dahdi_linux_extra updated to the 2.9.2 branch.
  * Use hotplug support:
    - patch hotplug_mod_params: change default of module parameters.
  * Multiarch support. 
  * udev rules moved to package dahdi (in source package dahdi-tools).
  * Add a test for non-free files in case uscan was used.
  * Remove unused variables from control file.

  [ Mark Purcell ]
  * Update debian/watch for ~dfsg

 -- Tzafrir Cohen <tzafrir@debian.org>  Tue, 19 Aug 2014 08:48:32 +0300

=== debian/control ===
--- 
+++ 
@@ -6,14 +6,15 @@
 Build-Depends: debhelper (>=  7.0.50~), bzip2, asciidoc
 Standards-Version: 3.9.4
 Homepage: http://www.asterisk.org/
-Vcs-Svn: svn://svn.debian.org/pkg-voip/dahdi-linux/trunk/
+Vcs-Svn: svn://anonscm.debian.org/pkg-voip/dahdi-linux/trunk/
 Vcs-Browser: http://anonscm.debian.org/viewvc/pkg-voip/dahdi-linux/
 
 Package: dahdi-linux
 Architecture: all
+Multi-Arch: foreign
 # Xorcom packages depend on dahdi-firmware. Debian zaptel will probably 
 # just recommend it.
-Depends: ${shlibs:Depends}, ${misc:Depends}, procps, fxload
+Depends: ${misc:Depends}, procps, fxload
 Replaces: zaptel
 Conflicts: zaptel
 Description: DAHDI telephony interface - Linux userspace parts
@@ -25,6 +26,7 @@
  configuration, xpp initialization scripts.
 
 Package: dahdi-source
+Multi-Arch: foreign
 Section: kernel
 Architecture: all
 Depends: ${misc:Depends}, debhelper (>> 4.0), module-assistant (>= 0.8.1), bzip2

=== debian/rules ===
--- 
+++ 
@@ -68,7 +68,12 @@
 
 ## END OF M-A SECTION
 
+# FIXME: this should be done by Files-Exclude in debian/copyright:
 override_dh_auto_build:
+ifneq ($(wildcard drivers/dahdi/xpp/firmwares/USB_FW.hex),)
+	@echo "Tarball is not DFSG-compliant. Use './debian/rules get-orig-source'"
+	exit 1
+endif
 	$(MAKE) docs
 	$(MAKE) $(GENERATED_SOURCES)
